## photoqt 2.5

=== CMakeLists.txt ===
##############################################
# CMakeLists for PhotoQt: http://photoqt.org #
##############################################

cmake_minimum_required(VERSION 3.16)
project(photoqt LANGUAGES CXX)


##################################################################
####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
##################################################################

add_definitions(-DVERSION="2.5")


########################################
####  SOME SETTINGS/FLAGS FOR CMAKE ####
########################################

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


#############################
####  GET list of files  ####
#############################

include(CMake/ListFilesCPlusPlus.cmake)
include(CMake/ListFilesResources.cmake)


#############################################
#### OPTIONS THAT CAN BE SET BY THE USER ####
#############################################

option(RAW "Use libraw library" ON)
option(EXIV2 "Use exiv2 library" ON)
option(OLDEXIV2 "Use exiv2 library (v0.25 or older)" OFF)
option(GRAPHICSMAGICK "Use GraphicsMagick library" ON)
option(IMAGEMAGICK "Use ImageMagick library" OFF)
option(DEVIL "Use DevIL library" ON)
option(FREEIMAGE "Use FreeImage library" ON)
option(POPPLER "Use Poppler library" ON)
option(LIBARCHIVE "Enable features that require libarchive" ON)
option(PUGIXML "Enable features that require pugixml" ON)
option(VIDEO "Enable video support" ON)
option(CHROMECAST "Enable Chromecast support" ON)

# name of this option changed
# this helps to make sure nothing breaks
if(GM)
    message("")
    message("** DEPRECATED OPTION to enable GraphicsMagick used: GM")
    message("** Support of this name will be removed in a future version")
    message("** Please use new option name: GRAPHICSMAGICK")
    message("** (make sure to remove GM variable from cmake cache)")
    message("")
    set(GRAPHICSMAGICK ON)
endif()

################################
#### FIND REQUIRED PACKAGES ####
################################

find_package(Qt5 COMPONENTS Core Quick Xml Svg Multimedia DBus LinguistTools Sql REQUIRED)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
if(IMAGEMAGICK)
    find_package(ImageMagick COMPONENTS Magick++)
    if(GRAPHICSMAGICK)
        set(GRAPHICSMAGICK OFF)
        message("** ImageMagick and GraphicsMagick cannot be used at the same time")
    endif()
endif()
if(GRAPHICSMAGICK)
    find_package(GraphicsMagick)
endif()
if(OLDEXIV2)
    set(EXIV2 Off)
    # this uses a custom shipped FindLibExiv2.cmake file
    # as versions 0.25 and older do not provide one yet
    find_package(LibExiv2 REQUIRED)
endif()
if(EXIV2)
    find_package(exiv2 REQUIRED)
    if(WIN32)
        find_package(Threads)
        find_package(Iconv)
    endif()
endif()
if(RAW)
    find_package(LibRaw)
endif()
if(FREEIMAGE)
    find_package(FreeImage)
endif()
if(LIBARCHIVE)
    find_package(LibArchive)
endif()
if(NOT WIN32)
    find_package(ECM REQUIRED NO_MODULE)
    set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_MODULE_PATH}")
    if(POPPLER)
        find_package(Poppler COMPONENTS Qt5)
    endif()
endif()
if(DEVIL)
    find_package(DevIL)
endif()
if(CHROMECAST)
    find_package(Python3 COMPONENTS Interpreter Development)
endif()

# Since Python might be imported we have to avoid using Qt keywords (like 'slots') to avoid naming conflicts
ADD_DEFINITIONS(-DQT_NO_KEYWORDS)


######################
#### TRANSLATIONS ####
######################

# We first copy the most recent *.ts files to the build directory and then process them
# This way, we don't have to mess with files outside of the build folder

file(GLOB files "lang/*.ts")
foreach(file ${files})
   get_filename_component(filename ${file} NAME)
   file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/lang/${filename} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
   qt5_add_translation(qm_files ${CMAKE_CURRENT_BINARY_DIR}/${filename})
endforeach()
add_custom_target(translations ALL DEPENDS ${qm_files})

# Create the lang resource file
include("CMake/ComposeLangResourceFile.cmake")
composeLangResourceFile()

#############################
#### Add the executeable ####
#############################

# on windows we add application icons
if(WIN32)
    add_executable(${PROJECT_NAME} WIN32 ${photoqt_SOURCES} ${photoqt_RESOURCES} ${qm_files} windowsicons.rc)
elseif(NOT WIN32)
    add_executable(${PROJECT_NAME} ${photoqt_SOURCES} ${photoqt_QML} ${photoqt_RESOURCES} ${qm_files})
endif()
target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::Xml Qt5::Svg Qt5::Multimedia Qt5::DBus Qt5::Sql)

######################################################
#### CMAKE BUILD TYPE (DETERMINES COMPILER FLAGS) ####
######################################################

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

if(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    add_definitions(-DPHOTOQTDEBUG)
    target_compile_definitions(${PROJECT_NAME} PRIVATE QT_QML_DEBUG)
    target_compile_options(${PROJECT_NAME} PRIVATE -Wall -pedantic -Wextra -O0 -g)
endif()


##############################################
#### COMPOSE THE APPROPRIATE DESKTOP FILE ####
##############################################

include("CMake/ComposeDesktopFile.cmake")
composeDesktopFile()


###############################
#### SPECIAL WINDOWS FLAGS ####
###############################

if(WIN32)
    add_definitions(-DWIN32_LEAN_AND_MEAN)
endif()


########################
#### CUSTOM OPTIONS ####
########################

if(PUGIXML)
    add_definitions(-DPUGIXML)
    target_link_libraries(${PROJECT_NAME} "pugixml")
endif()

if(VIDEO)
    add_definitions(-DVIDEO)
endif()

if(LIBARCHIVE)
    if(NOT ${LibArchive_FOUND})
        message(FATAL_ERROR "** Unable to locate LibArchive... is it installed?")
    else()
        include_directories(${LibArchive_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${LibArchive_LIBRARIES})
        message("** Using LibArchive " ${LibArchive_VERSION})
        add_definitions(-DLIBARCHIVE)
    endif()
else()
    message("** LibArchive disabled")
endif()

if(POPPLER)
    if(NOT ${Poppler_FOUND})
        message(FATAL_ERROR "** Unable to locate Poppler... is it installed?")
    else()
        include_directories(${Poppler_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${Poppler_LIBRARIES})
        message("** Using Poppler ${Poppler_VERSION}")
        add_definitions(-DPOPPLER)
    endif()
else()
    message("** Poppler DISABLED")
endif()

if(DEVIL)
    if(NOT ${IL_FOUND})
        message(FATAL_ERROR "** Unable to locate DevIL... is it installed?")
    else()
        include_directories(${IL_INCLUDE_DIR})
        target_link_libraries(${PROJECT_NAME} ${IL_LIBRARIES})
        message("** Using DevIL")
        add_definitions(-DDEVIL)
    endif()
else()
    message("** DevIL DISABLED")
endif()

if(FREEIMAGE)
    if(NOT ${FREEIMAGE_FOUND})
        message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
    else()
        include_directories(${FREEIMAGE_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${FREEIMAGE_LIBRARIES})
        message("** Using FreeImage")
        add_definitions(-DFREEIMAGE)
    endif()
else()
    message("** FreeImage DISABLED")
endif()

if(RAW)
    if(NOT ${LIBRAW_FOUND})
        message(FATAL_ERROR "** Unable to locate LibRaw... is it installed?")
    else()
        include_directories(${LIBRAW_INCLUDE_DIR})
        target_link_libraries(${PROJECT_NAME} "raw")
         message("** Using LibRaw")
        add_definitions(-DRAW)
    endif()
else()
    message("** LibRaw DISABLED")
endif()

if(EXIV2)
    if(NOT ${exiv2_FOUND})
        message(FATAL_ERROR "** Unable to locate Exiv2... is it installed?")
    else()
        include_directories(${EXIV2_INCLUDE_DIR})
        target_link_libraries(${PROJECT_NAME} "exiv2lib")
        add_definitions(-DEXIV2)
        message("** Using Exiv2 ${exiv2_VERSION}")
    endif()
elseif(OLDEXIV2)
    if(NOT ${LibExiv2_FOUND})
        message(FATAL_ERROR "** Unable to locate Exiv2... is it installed?")
    else()
        include_directories(${LibExiv2_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${LibExiv2_LIBRARIES})
        add_definitions(-DEXIV2)
        message("** Using Exiv2 ${LibExiv2_VERSION}")
    endif()
else()
    message("** Exiv2 DISABLED")
endif()

if(GRAPHICSMAGICK)
    if(NOT ${MAGICK++_FOUND})
        message(FATAL_ERROR "** Unable to locate GraphicsMagick... is it installed?")
    else()
        include_directories(${MAGICK++_INCLUDE_DIR})
        target_link_libraries(${PROJECT_NAME} "GraphicsMagick++")
        add_definitions(-DGRAPHICSMAGICK)
        message("** Using Graphicsmagick")
    endif()
else()
    message("** Graphicsmagick DISABLED")
endif()

if(IMAGEMAGICK)
    if(NOT ${ImageMagick_FOUND})
        message(FATAL_ERROR "** Unable to locate ImageMagick... is it installed?")
    else()
        include_directories(${ImageMagick_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${ImageMagick_LIBRARIES})
        add_definitions(-DIMAGEMAGICK)
        add_definitions(-DMAGICKCORE_QUANTUM_DEPTH=16)
        add_definitions(-DMAGICKCORE_HDRI_ENABLE=1)
        message("** Using ImageMagick")
    endif()
else()
    message("** ImageMagick DISABLED")
endif()

if(CHROMECAST)
    if(NOT ${Python3_FOUND})
        message(FATAL_ERROR "** Unable to locate Python3... is it installed?")
    elseif(NOT ${Python3_Interpreter_FOUND})
        message(FATAL_ERROR "** Unable to locate Python3 Interpreter... is it installed?")
    else()
        execute_process(COMMAND ${Python3_EXECUTABLE} -c "import pychromecast" RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
        if(NOT ${EXIT_CODE} EQUAL 0)
            # try installing it with pip
            message(">> Attempt to install pychromecast locally using pip...")
            execute_process(COMMAND ${Python3_EXECUTABLE} -m pip install pychromecast --user RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
            execute_process(COMMAND ${Python3_EXECUTABLE} -c "import pychromecast" RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
            if(NOT ${EXIT_CODE} EQUAL 0)
                message(FATAL_ERROR "** Unable to locate Python3 module pychromecast. Please first install it or disable Chromecast support.")
            else()
                message(">> Success!")
            endif()
        endif()
        include_directories(${Python3_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} ${Python3_LIBRARIES})
        message("** Chromecast support enabled")
        message("** Using Python ${Python3_VERSION}")
        add_definitions(-DCHROMECAST)
    endif()
else()
    message("** Chromecast support DISABLED")
endif()


#######################
#### INSTALL FILES ####
#######################

if(UNIX)

    # Install executeable
    install(
        TARGETS ${PROJECT_NAME}
        DESTINATION bin/
    )

    # Install desktop file
    install(
        FILES org.photoqt.PhotoQt.desktop
        DESTINATION share/applications
    )
    install(
        FILES org.photoqt.PhotoQt.standalone.desktop
        DESTINATION share/applications
    )

    # And install all the icons
    install(
        FILES icons/16x16/apps/photoqt.png
        DESTINATION share/icons/hicolor/16x16/apps/
    )
    install(
        FILES icons/32x32/apps/photoqt.png
        DESTINATION share/icons/hicolor/32x32/apps/
    )
    install(
        FILES icons/48x48/apps/photoqt.png
        DESTINATION share/icons/hicolor/48x48/apps/
    )
    install(
        FILES icons/64x64/apps/photoqt.png
        DESTINATION share/icons/hicolor/64x64/apps/
    )
    install(
        FILES icons/128x128/apps/photoqt.png
        DESTINATION share/icons/hicolor/128x128/apps/
    )
    install(
        FILES org.photoqt.PhotoQt.appdata.xml
        DESTINATION share/appdata/
    )

endif()

=== debian/changelog ===
photoqt (2.5-4) unstable; urgency=medium

  * d/control: add missing build-depends for graphicsmagick.

 -- Gürkan Myczko <tar@debian.org>  Fri, 25 Mar 2022 20:55:55 +0100

photoqt (2.5-3) unstable; urgency=medium

  * Fix some FTBFS problems, thanks to Lukas Spies and Adrian Bunk:
    - d/rules: adapt cmake options depending on architecture.
    - d/control: limit build-depends for arch.

 -- Gürkan Myczko <tar@debian.org>  Wed, 23 Mar 2022 19:41:09 +0100

photoqt (2.5-2) unstable; urgency=medium

  * d/control: add python3-pychromecast to Depends.
  * Source only upload.

 -- Gürkan Myczko <tar@debian.org>  Wed, 23 Mar 2022 05:58:50 +0100

photoqt (2.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1008066)

 -- Gürkan Myczko <tar@debian.org>  Thu, 17 Mar 2022 12:39:25 +0100

=== debian/control ===
Source: photoqt
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 libexiv2-dev,
 libmagick++-6.q16-dev [!kfreebsd-amd64 !kfreebsd-i386],
 libgraphicsmagick1-dev,
 libgraphicsmagick++1-dev,
 libraw-dev,
 libfreeimageplus-dev [!hppa !powerpc !ppc64],
 libdevil-dev,
 libpoppler-cpp-dev,
 libpoppler-qt5-dev,
 libarchive-dev,
 libpugixml-dev,
 libqt5svg5-dev,
 python3-pip,
 python3-dev,
 python3-requests,
 python3-pychromecast [!ia64],
 qtbase5-dev,
 qt5-qmake,
 qttools5-dev,
 qtmultimedia5-dev,
 qtdeclarative5-dev
Standards-Version: 4.6.0
Homepage: https://photoqt.org/
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git
Rules-Requires-Root: no

Package: photoqt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-pychromecast
Description: Fast and highly configurable image viewer
 This is a fast and highly configurable image viewer with a simple and nice
 interface.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(DEB_BUILD_ARCH_OS),kfreebsd)
    MAGICK = -DGRAPHICSMAGICK=OFF -DIMAGEMAGICK=OFF
endif
ifeq ($(DEB_BUILD_ARCH_OS),ia64)
    CHROMECAST = -DCHROMECAST=OFF
endif
ifeq ($(DEB_BUILD_ARCH_OS),hppa)
    FI = -DFREEIMAGE=OFF
endif
ifeq ($(DEB_BUILD_ARCH_OS),powerpc)
    FI = -DFREEIMAGE=OFF
endif
ifeq ($(DEB_BUILD_ARCH_OS),ppc64)
    FI = -DFREEIMAGE=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_POPPLER=OFF \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	$(MAGICK) \
	$(CHROMECAST) \
	$(FI)

## photoqt 2.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-add_definitions(-DVERSION="2.5")
+add_definitions(-DVERSION="2.8")
 
 
 ########################################
@@ -46,8 +46,10 @@
 option(POPPLER "Use Poppler library" ON)
 option(LIBARCHIVE "Enable features that require libarchive" ON)
 option(PUGIXML "Enable features that require pugixml" ON)
-option(VIDEO "Enable video support" ON)
+option(VIDEO_QT "Enable video support through Qt" ON)
+option(VIDEO_MPV "Enable video support through MPV" OFF)
 option(CHROMECAST "Enable Chromecast support" ON)
+option(LIBVIPS "Use libvips" OFF)
 
 # name of this option changed
 # this helps to make sure nothing breaks
@@ -60,12 +62,19 @@
     message("")
     set(GRAPHICSMAGICK ON)
 endif()
+if(VIDEO)
+    message("")
+    message("** The VIDEO cmake flag was changed to VIDEO_QT")
+    message("** This was done to distinguish it from VIDEO_MPV")
+    message("")
+    set(VIDEO_QT ON)
+endif()
 
 ################################
 #### FIND REQUIRED PACKAGES ####
 ################################
 
-find_package(Qt5 COMPONENTS Core Quick Xml Svg Multimedia DBus LinguistTools Sql REQUIRED)
+find_package(Qt5 COMPONENTS Core Quick Xml Svg Multimedia DBus LinguistTools Sql PrintSupport REQUIRED)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
 if(IMAGEMAGICK)
@@ -86,10 +95,6 @@
 endif()
 if(EXIV2)
     find_package(exiv2 REQUIRED)
-    if(WIN32)
-        find_package(Threads)
-        find_package(Iconv)
-    endif()
 endif()
 if(RAW)
     find_package(LibRaw)
@@ -112,6 +117,13 @@
 endif()
 if(CHROMECAST)
     find_package(Python3 COMPONENTS Interpreter Development)
+endif()
+if(LIBVIPS)
+    find_package(PkgConfig REQUIRED)
+    pkg_search_module(GLIB REQUIRED glib-2.0 gobject-2.0)
+endif()
+if(VIDEO_MPV)
+    find_package(Libmpv)
 endif()
 
 # Since Python might be imported we have to avoid using Qt keywords (like 'slots') to avoid naming conflicts
@@ -147,7 +159,7 @@
 elseif(NOT WIN32)
     add_executable(${PROJECT_NAME} ${photoqt_SOURCES} ${photoqt_QML} ${photoqt_RESOURCES} ${qm_files})
 endif()
-target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::Xml Qt5::Svg Qt5::Multimedia Qt5::DBus Qt5::Sql)
+target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::Xml Qt5::Svg Qt5::Multimedia Qt5::DBus Qt5::Sql Qt5::PrintSupport)
 
 ######################################################
 #### CMAKE BUILD TYPE (DETERMINES COMPILER FLAGS) ####
@@ -190,8 +202,8 @@
     target_link_libraries(${PROJECT_NAME} "pugixml")
 endif()
 
-if(VIDEO)
-    add_definitions(-DVIDEO)
+if(VIDEO_QT)
+    add_definitions(-DVIDEOQT)
 endif()
 
 if(LIBARCHIVE)
@@ -337,56 +349,23 @@
     message("** Chromecast support DISABLED")
 endif()
 
-
-#######################
-#### INSTALL FILES ####
-#######################
-
-if(UNIX)
-
-    # Install executeable
-    install(
-        TARGETS ${PROJECT_NAME}
-        DESTINATION bin/
-    )
-
-    # Install desktop file
-    install(
-        FILES org.photoqt.PhotoQt.desktop
-        DESTINATION share/applications
-    )
-    install(
-        FILES org.photoqt.PhotoQt.standalone.desktop
-        DESTINATION share/applications
-    )
-
-    # And install all the icons
-    install(
-        FILES icons/16x16/apps/photoqt.png
-        DESTINATION share/icons/hicolor/16x16/apps/
-    )
-    install(
-        FILES icons/32x32/apps/photoqt.png
-        DESTINATION share/icons/hicolor/32x32/apps/
-    )
-    install(
-        FILES icons/48x48/apps/photoqt.png
-        DESTINATION share/icons/hicolor/48x48/apps/
-    )
-    install(
-        FILES icons/64x64/apps/photoqt.png
-        DESTINATION share/icons/hicolor/64x64/apps/
-    )
-    install(
-        FILES icons/128x128/apps/photoqt.png
-        DESTINATION share/icons/hicolor/128x128/apps/
-    )
-    install(
-        FILES org.photoqt.PhotoQt.appdata.xml
-        DESTINATION share/appdata/
-    )
-
-endif()
-
-
-
+if(LIBVIPS)
+    include_directories(${GLIB_INCLUDE_DIRS})
+    target_link_libraries(${PROJECT_NAME} ${GLIB_LIBRARIES})
+    target_link_libraries(${PROJECT_NAME} "vips")
+    target_link_libraries(${PROJECT_NAME} "gobject-2.0")
+    target_link_libraries(${PROJECT_NAME} "vips-cpp")
+    add_definitions(-DLIBVIPS)
+    message("** Using libvips")
+else()
+    message("** libvips DISABLED")
+endif()
+
+if(VIDEO_MPV)
+    if(NOT ${Libmpv_FOUND})
+        message(FATAL_ERROR "** Unable to locate libmpv... is it installed?")
+    else()
+        include_directories(${Libmpv_INCLUDE_DIRS})
+        target_link_libraries(${PROJECT_NAME} ${Libmpv_LIBRARIES})
+        message("** Using libmpv " ${Libmpv_VERSION})
+        add_definitions(-DVIDEOMPV)

=== debian/changelog ===
photoqt (2.8-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Wed, 03 Aug 2022 16:20:44 +0200

photoqt (2.7-1) unstable; urgency=medium

  * New upstream version.
  * d/upstream/metadata: added.
  * Bump standards version to 4.6.1.

 -- Gürkan Myczko <tar@debian.org>  Sun, 12 Jun 2022 08:05:28 +0200

photoqt (2.6-1) unstable; urgency=medium

  * New upstream version.
  * Patched upstream CMakeLists.txt to not do the pychromecast check.

 -- Gürkan Myczko <tar@debian.org>  Fri, 08 Apr 2022 08:55:33 +0200

photoqt (2.5-5) unstable; urgency=medium

  * d/control: improve arch exceptions for pychromecast.

 -- Gürkan Myczko <tar@debian.org>  Sat, 26 Mar 2022 17:06:50 +0100

=== debian/control ===
--- 
+++ 
@@ -21,13 +21,13 @@
  python3-pip,
  python3-dev,
  python3-requests,
- python3-pychromecast [!ia64],
+ python3-pychromecast [!ia64 !kfreebsd-amd64 !kfreebsd-i386 !sparc64 !sh4 !riscv64 !m68k !hppa !mips64el],
  qtbase5-dev,
  qt5-qmake,
  qttools5-dev,
  qtmultimedia5-dev,
  qtdeclarative5-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git

## photoqt 3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-add_definitions(-DVERSION="2.8")
+add_definitions(-DVERSION="3.0")
 
 
 ########################################
@@ -70,6 +70,7 @@
     set(VIDEO_QT ON)
 endif()
 
+
 ################################
 #### FIND REQUIRED PACKAGES ####
 ################################
@@ -99,8 +100,10 @@
 if(RAW)
     find_package(LibRaw)
 endif()
-if(FREEIMAGE)
-    find_package(FreeImage)
+if(NOT WIN32)
+    if(FREEIMAGE)
+        find_package(FreeImage)
+    endif()
 endif()
 if(LIBARCHIVE)
     find_package(LibArchive)
@@ -184,15 +187,6 @@
 composeDesktopFile()
 
 
-###############################
-#### SPECIAL WINDOWS FLAGS ####
-###############################
-
-if(WIN32)
-    add_definitions(-DWIN32_LEAN_AND_MEAN)
-endif()
-
-
 ########################
 #### CUSTOM OPTIONS ####
 ########################
@@ -220,39 +214,58 @@
 endif()
 
 if(POPPLER)
-    if(NOT ${Poppler_FOUND})
-        message(FATAL_ERROR "** Unable to locate Poppler... is it installed?")
-    else()
-        include_directories(${Poppler_INCLUDE_DIRS})
-        target_link_libraries(${PROJECT_NAME} ${Poppler_LIBRARIES})
-        message("** Using Poppler ${Poppler_VERSION}")
+    if(WIN32)
+        message("** Using Poppler")
+        target_link_libraries(${PROJECT_NAME} "poppler")
+        target_link_libraries(${PROJECT_NAME} "poppler-qt5")
         add_definitions(-DPOPPLER)
+    else()
+        if(NOT ${Poppler_FOUND})
+            message(FATAL_ERROR "** Unable to locate Poppler... is it installed?")
+        else()
+            include_directories(${Poppler_INCLUDE_DIRS})
+            target_link_libraries(${PROJECT_NAME} ${Poppler_LIBRARIES})
+            message("** Using Poppler ${Poppler_VERSION}")
+            add_definitions(-DPOPPLER)
+        endif()
     endif()
 else()
     message("** Poppler DISABLED")
 endif()
 
 if(DEVIL)
-    if(NOT ${IL_FOUND})
-        message(FATAL_ERROR "** Unable to locate DevIL... is it installed?")
-    else()
-        include_directories(${IL_INCLUDE_DIR})
-        target_link_libraries(${PROJECT_NAME} ${IL_LIBRARIES})
+    if(WIN32)
+        target_link_libraries(${PROJECT_NAME} "DevIL")
         message("** Using DevIL")
         add_definitions(-DDEVIL)
+    else()
+        if(NOT ${DevIL_FOUND})
+            message(FATAL_ERROR "** Unable to locate DevIL... is it installed?")
+        else()
+            include_directories(${IL_INCLUDE_DIR})
+            target_link_libraries(${PROJECT_NAME} ${IL_LIBRARIES})
+            message("** Using DevIL")
+            add_definitions(-DDEVIL)
+        endif()
     endif()
 else()
     message("** DevIL DISABLED")
 endif()
 
 if(FREEIMAGE)
-    if(NOT ${FREEIMAGE_FOUND})
-        message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
-    else()
-        include_directories(${FREEIMAGE_INCLUDE_DIRS})
-        target_link_libraries(${PROJECT_NAME} ${FREEIMAGE_LIBRARIES})
+    if(WIN32)
+        target_link_libraries(${PROJECT_NAME} "FreeImage")
         message("** Using FreeImage")
         add_definitions(-DFREEIMAGE)
+    else()
+        if(NOT ${FREEIMAGE_FOUND})
+            message(FATAL_ERROR "** Unable to locate FreeImage... is it installed?")
+        else()
+            include_directories(${FREEIMAGE_INCLUDE_DIRS})
+            target_link_libraries(${PROJECT_NAME} ${FREEIMAGE_LIBRARIES})
+            message("** Using FreeImage")
+            add_definitions(-DFREEIMAGE)
+        endif()
     endif()
 else()
     message("** FreeImage DISABLED")
@@ -263,8 +276,12 @@
         message(FATAL_ERROR "** Unable to locate LibRaw... is it installed?")
     else()
         include_directories(${LIBRAW_INCLUDE_DIR})
-        target_link_libraries(${PROJECT_NAME} "raw")
-         message("** Using LibRaw")
+        if(WIN32)
+            target_link_libraries(${PROJECT_NAME} "libraw")
+        else()
+            target_link_libraries(${PROJECT_NAME} "raw")
+        endif()
+        message("** Using LibRaw")
         add_definitions(-DRAW)
     endif()
 else()
@@ -351,21 +368,3 @@
 
 if(LIBVIPS)
     include_directories(${GLIB_INCLUDE_DIRS})
-    target_link_libraries(${PROJECT_NAME} ${GLIB_LIBRARIES})
-    target_link_libraries(${PROJECT_NAME} "vips")
-    target_link_libraries(${PROJECT_NAME} "gobject-2.0")
-    target_link_libraries(${PROJECT_NAME} "vips-cpp")
-    add_definitions(-DLIBVIPS)
-    message("** Using libvips")
-else()
-    message("** libvips DISABLED")
-endif()
-
-if(VIDEO_MPV)
-    if(NOT ${Libmpv_FOUND})
-        message(FATAL_ERROR "** Unable to locate libmpv... is it installed?")
-    else()
-        include_directories(${Libmpv_INCLUDE_DIRS})
-        target_link_libraries(${PROJECT_NAME} ${Libmpv_LIBRARIES})
-        message("** Using libmpv " ${Libmpv_VERSION})
-        add_definitions(-DVIDEOMPV)

=== debian/changelog ===
photoqt (3.0-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * d/control:
    - add qml-module-qt-labs-platform to Depends.
    - add kimageformats-plugins to Recommends.

 -- Gürkan Myczko <tar@debian.org>  Wed, 01 Feb 2023 07:57:52 +0100

photoqt (2.9.1-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 05 Sep 2022 21:08:44 +0200

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,8 @@
 
 Package: photoqt
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python3-pychromecast
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3-pychromecast, qml-module-qt-labs-platform
+Recommends: kimageformat-plugins
 Description: Fast and highly configurable image viewer
  This is a fast and highly configurable image viewer with a simple and nice
  interface.

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,9 @@
     MAGICK = -DGRAPHICSMAGICK=OFF -DIMAGEMAGICK=OFF
 endif
 ifeq ($(DEB_BUILD_ARCH_OS),ia64)
+    CHROMECAST = -DCHROMECAST=OFF
+endif
+ifeq ($(DEB_BUILD_ARCH_OS),x86_64)
     CHROMECAST = -DCHROMECAST=OFF
 endif
 ifeq ($(DEB_BUILD_ARCH_OS),hppa)

## photoqt 3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-add_definitions(-DVERSION="3.0")
+add_definitions(-DVERSION="3.1")
 
 
 ########################################
@@ -51,6 +51,8 @@
 option(CHROMECAST "Enable Chromecast support" ON)
 option(LIBVIPS "Use libvips" OFF)
 
+option(EXIV2_ENABLE_BMFF "Enable BMFF format support in Exiv2 (if available)" ON)
+
 # name of this option changed
 # this helps to make sure nothing breaks
 if(GM)
@@ -296,6 +298,9 @@
         target_link_libraries(${PROJECT_NAME} "exiv2lib")
         add_definitions(-DEXIV2)
         message("** Using Exiv2 ${exiv2_VERSION}")
+        if(EXIV2_ENABLE_BMFF)
+            add_definitions(-DEXIV2_ENABLE_BMFF)
+        endif()
     endif()
 elseif(OLDEXIV2)
     if(NOT ${LibExiv2_FOUND})
@@ -360,11 +365,3 @@
         target_link_libraries(${PROJECT_NAME} ${Python3_LIBRARIES})
         message("** Chromecast support enabled")
         message("** Using Python ${Python3_VERSION}")
-        add_definitions(-DCHROMECAST)
-    endif()
-else()
-    message("** Chromecast support DISABLED")
-endif()
-
-if(LIBVIPS)
-    include_directories(${GLIB_INCLUDE_DIRS})

## photoqt 3.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ####  GLOBAL VERSION STRING FOR ALL FILES (INCLUDING CPP/QML) ####
 ##################################################################
 
-add_definitions(-DVERSION="3.1")
+add_definitions(-DVERSION="3.3")
 
 
 ########################################
@@ -39,17 +39,20 @@
 option(RAW "Use libraw library" ON)
 option(EXIV2 "Use exiv2 library" ON)
 option(OLDEXIV2 "Use exiv2 library (v0.25 or older)" OFF)
-option(GRAPHICSMAGICK "Use GraphicsMagick library" ON)
-option(IMAGEMAGICK "Use ImageMagick library" OFF)
+option(GRAPHICSMAGICK "Use GraphicsMagick library" OFF)
+option(IMAGEMAGICK "Use ImageMagick library" ON)
 option(DEVIL "Use DevIL library" ON)
 option(FREEIMAGE "Use FreeImage library" ON)
 option(POPPLER "Use Poppler library" ON)
+option(QTPDF "Use QtPDF module instead of Poppler" OFF)
 option(LIBARCHIVE "Enable features that require libarchive" ON)
 option(PUGIXML "Enable features that require pugixml" ON)
 option(VIDEO_QT "Enable video support through Qt" ON)
-option(VIDEO_MPV "Enable video support through MPV" OFF)
+option(VIDEO_MPV "Enable video support through MPV" ON)
 option(CHROMECAST "Enable Chromecast support" ON)
+option(CHROMECAST_PIPINSTALL "Allows CMake to attempt to install PyChromecast locally using pip." OFF)
 option(LIBVIPS "Use libvips" OFF)
+option(LOCATION "Enable use of QtPositioning/QtLocation QML modules" ON)
 
 option(EXIV2_ENABLE_BMFF "Enable BMFF format support in Exiv2 (if available)" ON)
 
@@ -71,13 +74,19 @@
     message("")
     set(VIDEO_QT ON)
 endif()
+if(QTPDF)
+    if(POPPLER)
+        set(POPPLER OFF)
+        message("** For displaying PDF documents you have to choose either Poppler OR QtPDF")
+    endif()
+endif()
 
 
 ################################
 #### FIND REQUIRED PACKAGES ####
 ################################
 
-find_package(Qt5 COMPONENTS Core Quick Xml Svg Multimedia DBus LinguistTools Sql PrintSupport REQUIRED)
+find_package(Qt5 COMPONENTS Core Quick Xml Svg Multimedia DBus LinguistTools Sql PrintSupport Concurrent REQUIRED)
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
 if(IMAGEMAGICK)
@@ -129,6 +138,10 @@
 endif()
 if(VIDEO_MPV)
     find_package(Libmpv)
+    set(photoqt_SOURCES ${photoqt_SOURCES} ${photoqt_libmpv_SOURCES})
+endif()
+if(QTPDF)
+    find_package(Qt5 COMPONENTS Pdf REQUIRED)
 endif()
 
 # Since Python might be imported we have to avoid using Qt keywords (like 'slots') to avoid naming conflicts
@@ -162,9 +175,12 @@
 if(WIN32)
     add_executable(${PROJECT_NAME} WIN32 ${photoqt_SOURCES} ${photoqt_RESOURCES} ${qm_files} windowsicons.rc)
 elseif(NOT WIN32)
-    add_executable(${PROJECT_NAME} ${photoqt_SOURCES} ${photoqt_QML} ${photoqt_RESOURCES} ${qm_files})
-endif()
-target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::Xml Qt5::Svg Qt5::Multimedia Qt5::DBus Qt5::Sql Qt5::PrintSupport)
+    add_executable(${PROJECT_NAME} ${photoqt_SOURCES} ${photoqt_RESOURCES} ${qm_files})
+endif()
+target_link_libraries(${PROJECT_NAME} Qt5::Core Qt5::Quick Qt5::Xml Qt5::Svg Qt5::Multimedia Qt5::DBus Qt5::Sql Qt5::PrintSupport Qt5::Concurrent)
+if(QTPDF)
+    target_link_libraries(${PROJECT_NAME} Qt5::Pdf)
+endif()
 
 ######################################################
 #### CMAKE BUILD TYPE (DETERMINES COMPILER FLAGS) ####
@@ -235,6 +251,11 @@
     message("** Poppler DISABLED")
 endif()
 
+if(QTPDF)
+    message("** Using QtPDF module")
+    add_definitions(-DQTPDF)
+endif()
+
 if(DEVIL)
     if(WIN32)
         target_link_libraries(${PROJECT_NAME} "DevIL")
@@ -351,17 +372,6 @@
     else()
         execute_process(COMMAND ${Python3_EXECUTABLE} -c "import pychromecast" RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
         if(NOT ${EXIT_CODE} EQUAL 0)
-            # try installing it with pip
-            message(">> Attempt to install pychromecast locally using pip...")
-            execute_process(COMMAND ${Python3_EXECUTABLE} -m pip install pychromecast --user RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
-            execute_process(COMMAND ${Python3_EXECUTABLE} -c "import pychromecast" RESULT_VARIABLE EXIT_CODE OUTPUT_QUIET TIMEOUT 2)
-            if(NOT ${EXIT_CODE} EQUAL 0)
-                message(FATAL_ERROR "** Unable to locate Python3 module pychromecast. Please first install it or disable Chromecast support.")
-            else()
-                message(">> Success!")
-            endif()
-        endif()
-        include_directories(${Python3_INCLUDE_DIRS})
-        target_link_libraries(${PROJECT_NAME} ${Python3_LIBRARIES})
-        message("** Chromecast support enabled")
-        message("** Using Python ${Python3_VERSION}")
+            if(CHROMECAST_PIPINSTALL)
+                # try installing it with pip
+                message(">> Attempt to install pychromecast locally using pip...")

=== debian/changelog ===
photoqt (3.3+ds-1.1build1) mantic; urgency=medium

  * Rebuild against new libraw23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 16 Jul 2023 10:09:32 +0200

photoqt (3.3+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Increase the timeout for the PyChromecast test and enable
    PyChromecast on all architectures. (Closes: #1038737)
  * Enable FreeImage on all architectures. (see #1002610)

 -- Adrian Bunk <bunk@debian.org>  Mon, 10 Jul 2023 01:28:08 +0300

photoqt (3.3+ds-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: add Files-Excluded.
  * d/control: add libmpv-dev to Build-Depends.

 -- Gürkan Myczko <tar@debian.org>  Mon, 19 Jun 2023 09:17:44 +0200

photoqt (3.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Sun, 11 Jun 2023 12:30:34 +0200

photoqt (3.2-1) experimental; urgency=medium

  * New upstream version.
  * d/control: added libvips-dev to build-depends.
  * d/control: disable MPV support.

 -- Gürkan Myczko <tar@debian.org>  Fri, 12 May 2023 16:13:45 +0200

photoqt (3.1-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Thu, 09 Mar 2023 09:11:09 +0100

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,10 @@
  libgraphicsmagick1-dev,
  libgraphicsmagick++1-dev,
  libraw-dev,
- libfreeimageplus-dev [!hppa !powerpc !ppc64],
+ libfreeimageplus-dev,
  libdevil-dev,
+ libvips-dev,
+ libmpv-dev,
  libpoppler-cpp-dev,
  libpoppler-qt5-dev,
  libarchive-dev,
@@ -21,13 +23,13 @@
  python3-pip,
  python3-dev,
  python3-requests,
- python3-pychromecast [!ia64 !kfreebsd-amd64 !kfreebsd-i386 !sparc64 !sh4 !riscv64 !m68k !hppa !mips64el],
+ python3-pychromecast,
  qtbase5-dev,
  qt5-qmake,
  qttools5-dev,
  qtmultimedia5-dev,
  qtdeclarative5-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://photoqt.org/
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/photoqt
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/photoqt.git

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(DEB_BUILD_ARCH_OS),kfreebsd)
    MAGICK = -DGRAPHICSMAGICK=OFF -DIMAGEMAGICK=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_POPPLER=OFF \
	-DVIDEO_MPV=ON \
	-DLIBVIPS=ON \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	$(MAGICK)
